SystemOrganization addCategory: #Ranking!

Object subclass: #EliminationPolicy
	instanceVariableNames: 'ranking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

EliminationPolicy subclass: #EliminationBelowRankOrder
	instanceVariableNames: 'rankOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!EliminationBelowRankOrder methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/2/2014 19:04'!
eliminateLastRankingEntryIfNeeded
	[self ranking sortedRanks last rankOrder > rankOrder]
		whileTrue:
			[self ranking sortedRanks removeLast.
			self ranking sortedAttenders removeLast]! !

!EliminationBelowRankOrder methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/25/2014 15:50'!
filterSortedRanks: aCollection 
	^aCollection select: [:each| each rankOrder <= rankOrder ].! !

!EliminationBelowRankOrder methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/25/2014 15:13'!
rankOrder: anInteger 
	rankOrder := anInteger ! !

!EliminationPolicy methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/2/2014 19:04'!
ranking
	^ ranking! !

!EliminationPolicy methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/25/2014 15:21'!
ranking: aRanking
	ranking := aRanking! !

EliminationPolicy subclass: #NoElimination
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!NoElimination methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/2/2014 18:59'!
eliminateLastRankingEntryIfNeeded
! !

!NoElimination methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/24/2014 19:28'!
filterSortedRanks: aCollection 
	^aCollection! !

Object subclass: #Ranking
	instanceVariableNames: 'sortDescriptor sortedRanks eliminationPolicy sortedAttenders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!Ranking methodsFor: 'adding' stamp: 'HwaJong 4/25/2014 14:41'!
addAllAttenders: aCollection 
	aCollection do: [:each| self addAttender: each ]! !

!Ranking methodsFor: 'adding' stamp: 'HwaJong 5/2/2014 19:01'!
addAttender: anObject 
	
	self sortedRanks isEmpty
		ifTrue: 
			[self sortedRanks: nil.
			self sortedAttenders add: anObject]
		ifFalse: 
			[self sortedRanks 
			detect: 
				[:rankEntry| 
					self sortDescriptor object1: rankEntry attender object2: anObject 
						ifSame: [true]
						ifInOrder: [false]
						ifNotInOrder: [false] ]
					ifFound: 
						[:x|
						|sai nextRankIndex|
						self sortedAttenders add: anObject.
						sai := self sortedAttenders indexOf: anObject.
						self sortedRanks 
							add: 
								(RankingEntry new 
									ranking: self; 
									rankOrder: x rankOrder;
									attender: anObject)
							beforeIndex: sai.
						nextRankIndex := self sortedRanks detectIndex: [:each| each rankOrder > x rankOrder] ifNone: [].
						nextRankIndex ifNotNil: 
							[(self sortedRanks copyFrom: nextRankIndex to: self sortedRanks size) do: 
								#increaseRankOrderBy1].
						self eliminationPolicy eliminateLastRankingEntryIfNeeded]
					ifNone: 
						[self sortedRanks: nil.
						self sortedAttenders add: anObject]].! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/14/2013 19:53'!
attendersOfRankOrder: anInteger 
	^(self sortedRanks select: [:each| each rankOrder = anInteger ]) collect: [:each| each attender] ! !

!Ranking methodsFor: 'changing' stamp: 'HwaJong 4/25/2014 15:22'!
beEliminatingBelowRankOrder: anInteger 
	self eliminationPolicy: (EliminationBelowRankOrder new ranking: self; rankOrder: anInteger)! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/24/2014 19:25'!
eliminationPolicy
	^ eliminationPolicy setDefault: #eliminationPolicyDefault for: self withSetter: #eliminationPolicy:! !

!Ranking methodsFor: 'changing' stamp: 'HwaJong 4/24/2014 19:23'!
eliminationPolicy: anEliminationBelowRankOrder 
	eliminationPolicy := anEliminationBelowRankOrder ! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/25/2014 15:22'!
eliminationPolicyDefault
	^NoElimination new ranking: self! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/6/2014 19:06'!
rankOrderOfAttender: anObject
	^self sortedRanks 
		detect: [:sr|sr attender = anObject]
		ifFound: [:found| found rankOrder ]
		ifNone: [self error: 'failed to find attender']! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/26/2014 13:33'!
sortDescriptor
	^ sortDescriptor setDefault: #sortDescriptorDefault for: self withSetter: #sortDescriptor:! !

!Ranking methodsFor: 'changing' stamp: 'HwaJong 4/25/2014 15:10'!
sortDescriptor: anSortDescriptor 
	| attenders |
	sortDescriptor := anSortDescriptor.
	attenders := self sortedAttenders.
	self sortedAttenders: nil.
	self addAllAttenders: attenders! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/26/2014 13:34'!
sortDescriptorDefault
	^UnarySortDescriptor descendingBy: #yourself! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/25/2014 14:12'!
sortedAttenders
	^sortedAttenders setDefault: #sortedAttendersDefault for: self withSetter: #sortedAttenders:! !

!Ranking methodsFor: 'changing' stamp: 'HwaJong 4/25/2014 15:07'!
sortedAttenders: aCollection 
	self sortedRanks: nil.
	sortedAttenders := aCollection! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/25/2014 14:13'!
sortedAttendersDefault
	^SortedCollection sortBlock: self sortDescriptor ! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/25/2014 15:07'!
sortedRanks

	^sortedRanks setDefault: #sortedRanksDefault for: self withSetter: #sortedRanks:! !

!Ranking methodsFor: 'changing' stamp: 'HwaJong 9/11/2013 14:39'!
sortedRanks: aSequenceableCollection

	sortedRanks := aSequenceableCollection! !

!Ranking methodsFor: 'answering' stamp: 'HwaJong 4/26/2014 13:07'!
sortedRanksDefault

	| newSortedRanks|
	self sortedAttenders isEmpty ifTrue: [^{}].
	newSortedRanks := self sortedAttenders collect: 
		[:each| 
			RankingEntry new 
				ranking: self; 
				attender: each ].
	
	newSortedRanks first rankOrder: 1.

	2 to: newSortedRanks size do: [:index|
		| priorEntry unrankedYetEntry |
		priorEntry := newSortedRanks at: index-1.
		unrankedYetEntry := newSortedRanks at: index.
		unrankedYetEntry rankOrder: 
			(sortDescriptor
				object1: (priorEntry attender) 
				object2: (unrankedYetEntry attender) 
				ifSame: [priorEntry rankOrder]
				ifInOrder: [index]
				ifNotInOrder: [index])].
	newSortedRanks := self eliminationPolicy filterSortedRanks: newSortedRanks.
	^newSortedRanks ! !

Object subclass: #RankingEntry
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'rankOrder attender ranking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

RankingEntry class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!RankingEntry methodsFor: 'answering' stamp: 'HwaJong 2/16/2013 12:13'!
attender
	^ attender! !

!RankingEntry methodsFor: 'changing' stamp: 'HwaJong 2/16/2013 12:10'!
attender: anObject
	attender := anObject 
	! !

!RankingEntry methodsFor: 'comparing' stamp: 'HwaJong 4/25/2014 14:33'!
gettersForEquality
	^#(rankOrder ranking attender)! !

!RankingEntry methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/2/2014 18:54'!
increaseRankOrderBy1
	self rankOrder: self rankOrder + 1! !

!RankingEntry methodsFor: 'doing' stamp: 'HwaJong 8/6/2013 14:26'!
printOn: stream

	stream print: rankOrder.
	stream nextPutAll: ') '.
	ranking ifNotNil: 
		[
			(ranking sortDescriptor respondsTo: #aspect)
				ifTrue: [stream print: (self rankValue). stream space.]
		].
	stream print: attender.! !

!RankingEntry methodsFor: 'answering' stamp: 'HwaJong 2/16/2013 12:38'!
rankOrder
	^ rankOrder! !

!RankingEntry methodsFor: 'changing' stamp: 'HwaJong 2/16/2013 12:10'!
rankOrder: anInteger 
	rankOrder := anInteger! !

!RankingEntry methodsFor: 'answering' stamp: 'HwaJong 8/6/2013 14:27'!
rankValue
	^ranking sortDescriptor aspect value: attender! !

!RankingEntry methodsFor: 'accessing' stamp: 'HwaJong 4/25/2014 14:33'!
ranking
	^ ranking! !

!RankingEntry methodsFor: 'changing' stamp: 'HwaJong 8/6/2013 14:15'!
ranking: aRanking 
	ranking := aRanking ! !

TestCase subclass: #Ranking12312312Test
	instanceVariableNames: 'ranking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!Ranking12312312Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/25/2014 14:43'!
setUp
	super setUp.
	ranking := Ranking new.
	ranking addAllAttenders: #(1 2 3 1 2 3 1 2).
	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
! !

!Ranking12312312Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRank1
	self assert: ((ranking attendersOfRankOrder: 1) asArray)
	equals: #(3 3)! !

!Ranking12312312Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRank2
	self assert: ((ranking attendersOfRankOrder: 2) asArray)
	equals: #()! !

!Ranking12312312Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRank3
	self assert: ((ranking attendersOfRankOrder: 3) asArray)
	equals: #(2 2 2)! !

!Ranking12312312Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/6/2014 19:14'!
testRankOfAttender
	self assert: (ranking rankOrderOfAttender: 1) equals: 6! !

!Ranking12312312Test methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/2/2014 23:38'!
testSortedRanks

	self assert: ((ranking sortedRanks collect: [:each| {each rankOrder. each attender} ]) asArray)
	equals: #((1 3) (1 3) (3 2) (3 2) (3 2) (6 1) (6 1) (6 1))! !

TestCase subclass: #RankingTest
	instanceVariableNames: 'ranking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/26/2014 15:38'!
setUp
	super setUp.
	ranking := Ranking new.! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/26/2014 15:38'!
testAddAllAttenders

	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	
	ranking addAllAttenders: #(10 5 10 7 4).
	self assert: ranking sortedRanks asArray equals: 
		{RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 3; attender:7; ranking: ranking.
		RankingEntry new rankOrder: 4; attender:5; ranking: ranking.
		RankingEntry new rankOrder: 5; attender:4; ranking: ranking}.! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/2/2014 19:29'!
testAddAllAttendersSortedRanksAndSortedAttendersMeet

	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #size).
	
	ranking addAllAttenders: #('i' 'do' 'like' 'this' 'apple' 'that' 'is' 'not' 'as' 'red' 'as' 'it' 'should' 'be').
	
	1 to: 13 do: [ :index|
		(ranking sortedAttenders at: index)	 == ((ranking sortedRanks at: index) attender) ]! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/26/2014 15:38'!
testAddAttender

	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	
	ranking addAttender: 10.
	self assert: ranking sortedRanks asArray equals: 
		{RankingEntry new rankOrder: 1; attender:10; ranking: ranking}.

	ranking addAttender: 5.
	self assert: ranking sortedRanks asArray equals: 
		{RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 2; attender:5; ranking: ranking}.
	
	ranking addAttender: 10.
	self assert: ranking sortedRanks asArray equals: 
		{RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 3; attender:5; ranking: ranking}.
		
	ranking addAttender: 7.
	self assert: ranking sortedRanks asArray equals: 
		{RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 3; attender:7; ranking: ranking.
		RankingEntry new rankOrder: 4; attender:5; ranking: ranking}.
		
	ranking addAttender: 4.
	self assert: ranking sortedRanks asArray equals: 
		{RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 1; attender:10; ranking: ranking.
		RankingEntry new rankOrder: 3; attender:7; ranking: ranking.
		RankingEntry new rankOrder: 4; attender:5; ranking: ranking.
		RankingEntry new rankOrder: 5; attender:4; ranking: ranking}.! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/26/2014 15:38'!
testElimination1

	ranking beEliminatingBelowRankOrder: 1.
	ranking addAllAttenders: #(1 2 3 4 5 6 7 8 9 10).
	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	self assert: ((ranking sortedRanks collect: [:each| {each rankOrder. each attender} ]) asArray) equals: #((1 10))! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/26/2014 15:38'!
testElimination1Common3

	ranking beEliminatingBelowRankOrder: 1.
	ranking addAllAttenders: #(0 10 10 10).
	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	self assert: ((ranking sortedRanks collect: [:each| {each rankOrder. each attender} ]) asArray) equals: #((1 10) (1 10) (1 10))! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/26/2014 15:38'!
testElimination2

	ranking beEliminatingBelowRankOrder: 2.
	ranking addAllAttenders: #(1 2 3 4 5 6 7 8 9 10).
	ranking sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	self assert: ((ranking sortedRanks collect: [:each| {each rankOrder. each attender} ]) asArray) equals: #((1 10) (2 9))! !
